<template>
    <button v-if="!isFollowed && isFollowing" @click="follow()" class="btn-subscribe"> suivre en retour </button>
    <button v-if="!isFollowed && !isFollowing" @click="follow()" class="btn-subscribe"> suivre </button>
    <button v-if="isFollowed" @click="follow()" class="btn-unsubscribe"> ne plus suivre </button>
</template>

<script>

import axios from 'axios';
import { useStore } from '../store/store';
const store = useStore();


export default {
    name: 'FollowButton',

    props:{
        user: Object
    },

    data(){
        return {
            buttonStatus: "s'abonner",
            isFollowed: false,
            isFollowing: false
        }
    },

    mounted(){
        const store = useStore();
        const currentUser = store.getCurrentUser;
        const arrayUser = currentUser.followers


        
        const isFollowing = () => {
            return currentUser.following.find(el => el === this.user._id)
        }
        
        const alreadyAbonne = () => {
            return arrayUser.find(el => el === this.user._id)
        }

        if(alreadyAbonne() == undefined){
            return;
        }else{
            this.isFollowing = true;
        }


        if(isFollowing() == undefined){
            return;
        }else{
            this.isFollowed = true;
        }

    
        
    },
    
    methods: {
        follow(){
            const currentUser = store.currentUser;
            axios.post('http://localhost:3500/api/follow/' + this.user._id, {
                user: currentUser._id
            })
            .then(response => {
                if(response.data === "created"){
                    console.log(response.data)
                    // ON UPDATE LE STORE
                    store.$patch((state) => {
                        state.currentUser.following.push(this.user._id);
                        store.getUserById(this.user._id).followers.push(currentUser._id)
                    })
                    this.isFollowed = true
                    
                }
                else{
                    store.$patch((state) => {
                        state.currentUser.following.forEach((el, idx) => {
                            if(el == this.user._id){
                                state.currentUser.following.splice(idx, 1);
                            }
                        })
                        store.getUserById(this.user._id).followers.forEach((el, idx) =>{
                            if(el == currentUser._id){
                                store.getUserById(this.user._id).followers.splice(idx, 1);
                            }
                        })
                    })
                    this.isFollowed = false 
                }

            })
            .catch((error) => {
                console.log(error)
            }) 
        }
    }
}


</script>

<style scoped>

    .btn-subscribe{
        width: 9rem;
        height: 2.7rem;
        color: white;
        background-color: #3f729b;
        border: none;
        border-radius: 5px;
        font-size: 1.1rem;
    }

    .btn-unsubscribe{
        width: 9rem;
        height: 2.7rem;
        color: white;
        background-color: RED;
        border: none;
        border-radius: 5px;
        font-size: 1.1rem;
    }

</style>